<?php

add_shortcode( 'ssquiz_leaderboard', 'leaderboard_creater' );
add_shortcode( 'ssquiz_charts', 'charts_creater' );
add_shortcode( 'if', 'ssif_creater' );

function charts_creater()
{
	global $wpdb;
	$wpdb->show_errors(); 
	global $current_user;
	get_currentuserinfo();
	$user_id = $current_user->ID;
	$completed = $wpdb->get_var("SELECT count(DISTINCT quiz_id) FROM ssquiz_users WHERE user_id=$user_id and total=correct");
	$total_quizzes = $wpdb->get_var("SELECT count(*) FROM ssquiz_quizzes");
	$quiz_id = $wpdb->get_var("SELECT quiz_id FROM ssquiz_users WHERE user_id=$user_id ORDER BY correct/total LIMIT 1");
	$quiz_title = $wpdb->get_var("SELECT quiz FROM ssquiz_users WHERE user_id=$user_id ORDER BY correct/total LIMIT 1");
	$done = $wpdb->get_col("SELECT MAX(correct)/total FROM ssquiz_users WHERE user_id=$user_id GROUP BY quiz_id");

	if(count($done))
		$percent = intval(array_sum($done)/count($done)*100);
	else
		$percent = 0;
	$percent2 = $completed;
	$percent3 = $wpdb->get_var("SELECT count(*) FROM ssquiz_users WHERE user_id=$user_id");
	$quiz_id = 2;
	$quiz_link1 = $wpdb->get_var("SELECT id FROM {$wpdb->prefix}posts WHERE post_content REGEXP 'ssquiz id=$quiz_id( |\])' AND post_status LIKE 'publish' LIMIT 1");
	if($quiz_link1!="")
		$quiz_link = get_permalink($quiz_link1);

	if($completed<10)
		$message = "Just starting, eh?";
	else if($completed<25)
		$message = "Nicht schlecht";
	else if($completed<40)
		$message = "Großartig!";
		
	$temp = "<script src='".path_join(WP_PLUGIN_URL, basename( dirname( __FILE__ ) )."/raphael-min.js")."'></script>";
	$temp .= "<div style='position:relative;float: left;width: 150px;'>";
		$temp .= "<div id='holder'></div>";
		$temp .= "<div id='sstext'>Performance in percent</div>";
	$temp .= "</div><div style='position:relative;float: left;width: 150px;'>";
		$temp .= "<div id='holder2'></div>";
		$temp .= "<div id='sstext2'>Quizzes done of total $total_quizzes</div>";
	$temp .= "</div><div style='position:relative;float: left;width: 150px;'>";
		$temp .= "<div id='holder3'></div>";
		$temp .= "<div id='sstext3'>Quizzes taken<br />(incl. retakes)<div class='ssmsg'>$message</div></div>";
	$temp .="</div><div class='spacer' style='clear: both;'></div>";
	if($quiz_link > ""){
		$temp .= "<div'>";
			$temp .= "Our recommendation:<br /><b>You should learn more <a href='$quiz_link'>$quiz_title</a></b>";
		$temp .="</div>";
	}
	//$percent=0;
	if(!$percent2) $percent2=0;
	if(!$percent3) $percent3=0;
	
    $temp .= "<script>var percent = $percent, percent2 = $percent2, percent3 = $percent3, total_quizzes = $total_quizzes</script>";
	$temp .= "<script src='".path_join(WP_PLUGIN_URL, basename( dirname( __FILE__ ) )."/renderer.js")."'></script>";

	return "<div class='sscharts'>$temp</div>";
}

function leaderboard_creater()
{
	global $wpdb;
	$wpdb->show_errors();
	$total_quizzes = $wpdb->get_var("SELECT count(*) FROM ssquiz_quizzes");
	$temp = "<tr><td><b>Learner</b></td><td><b>Quizzes Taken</b></td><td><b>Performance</b></td></tr>";
	//$leaders = $wpdb->get_results("SELECT user_name, count(quiz_id) as quizzes, count(DISTINCT quiz_id) as percentage FROM ssquiz_users WHERE date_stamp between date_sub(now(),INTERVAL 1 WEEK) and now() GROUP BY user_id HAVING quizzes > 1 ORDER BY percentage DESC LIMIT 3");
	$leaders = $wpdb->get_results("SELECT user_name, avg(perform)*100 as performance, sum(quiz) as quizzes FROM (SELECT user_id, MAX(correct)/total as perform, user_name, count(quiz_id) as quiz FROM ssquiz_users WHERE date_stamp between date_sub(now(),INTERVAL 1 WEEK) and now() GROUP BY quiz_id, user_id) as sub GROUP BY user_id HAVING quizzes > 1 ORDER BY performance DESC LIMIT 3");

	foreach($leaders as $leader)
	{
		$temp .= "<tr><td>".$leader->user_name."</td><td>".$leader->quizzes."</td><td>".intval($leader->performance)."%</td></tr>";
	}
	return "<div class='leaderboard'><table>$temp</table></div>";
}

function ssif_creater($atts, $content = null)
{
	global $wpdb;
	$wpdb->show_errors(); 

	global $current_user;
	get_currentuserinfo();
	$user_id = $current_user->ID;
	
	$completed_ids = explode(",", $atts["completed_ids"]);
	
	if(!$completed_ids) return "<h2>".__("No conditional statement")."</h2>";
	
	$completed = $wpdb->get_col("SELECT quiz_id FROM ssquiz_users WHERE user_id=$user_id AND total=correct GROUP BY quiz_id");

	$temp = true;
	foreach($completed_ids as $id)
		if(!in_array($id, $completed))
			$temp = false;

	if($temp)
	{
		return '<div class="achievement">' . $content . '</div>';
	}
}